namespace ProjectAirPlane;

/// <summary>
///     ""
/// </summary>
public partial class FormAirPlane : Form
{
    /// <summary>
    /// -   
    /// </summary>
    private DrawningAirPlane? _drawningAirPlane;

    /// <summary>
    ///  
    /// </summary>
    public FormAirPlane()
    {
        InitializeComponent();
    }

    /// <summary>
    ///   
    /// </summary>
    private void Draw()
    {
        if (_drawningAirPlane == null)
        {
            return;
        }

        Bitmap bmp = new(pictureBoxAirPlane.Width, pictureBoxAirPlane.Height);
        Graphics gr = Graphics.FromImage(bmp);
        _drawningAirPlane.DrawTransport(gr);
        pictureBoxAirPlane.Image = bmp;
    }

    /// <summary>
    ///    ""
    /// </summary>
    /// <param name="sender"></param>
    /// <param name="e"></param>
    private void ButtonCreateAirPlane_Click(object sender, EventArgs e)
    {
        Random random = new();
        _drawningAirPlane = new DrawningAirPlane();
        _drawningAirPlane.Init(random.Next(100, 300), random.Next(1000, 3000),
            Color.FromArgb(random.Next(0, 256), random.Next(0, 256), random.Next(0, 256)),
            Color.FromArgb(random.Next(0, 256), random.Next(0, 256), random.Next(0, 256)),
            Convert.ToBoolean(random.Next(0, 2)), Convert.ToBoolean(random.Next(0, 2)), Convert.ToBoolean(random.Next(0, 2)));
        _drawningAirPlane.SetPictureSize(pictureBoxAirPlane.Width, pictureBoxAirPlane.Height);
        _drawningAirPlane.SetPosition(random.Next(10, 100), random.Next(10, 100));
        Draw();
    }

    /// <summary>
    ///     (  )
    /// </summary>
    /// <param name="sender"></param>
    /// <param name="e"></param>
    private void ButtonMove_Click(object sender, EventArgs e)
    {
        if (_drawningAirPlane == null)
        {
            return;
        }

        string name = ((Button)sender)?.Name ?? string.Empty;
        bool result = false;
        switch (name)
        {
            case "buttonUp":
                result = _drawningAirPlane.MoveTransport(DirectionType.Up);
                break;
            case "buttonDown":
                result = _drawningAirPlane.MoveTransport(DirectionType.Down);
                break;
            case "buttonLeft":
                result = _drawningAirPlane.MoveTransport(DirectionType.Left);
                break;
            case "buttonRight":
                result = _drawningAirPlane.MoveTransport(DirectionType.Right);
                break;
        }

        if (result)
        {
            Draw();
        }
    }
}